using System;
using System.Collections.Generic;
using System.Text;

namespace MEdiaSpaceCore
{
    public class Constants
    {
        // Networking constants
        public const String OFFICE_IP = "136.159.7.179"; //public const String OFFICE_IP = "136.159.7.33";
        public const int HEADER_FIELD_LENGTH = 4;
        public const int BUFFER_SIZE = 2048;

        // Networking constants
        public const int OFFICE_PORT = 8080;
        public const int SESSION_CHANNEL = 0;
        public const byte VIDEO_CHANNEL = 1;
        public const byte DATA_CHANNEL = 2;
        public const int NETWORK_CHECK_RATE = 10;                   // 10 ms between network checks

        // Imaging constants
        public const int BYTES_PER_PIXEL = 3;
        public const double MAX_FRAMERATE = 30.0;                   // 30 fps is the max!

        // Compression protocol enumeration
        public enum VIDEO_PROTOCOLS { RAW, JPEG };

        // UI Constants
        public const String HOME_NOT_CONNECTED_STRING = "(not connected)";
        public const String HOME_CONNECTED_STRING = "Saul's Home Office";
        public const int PBOX_MARGIN = 5;       // The outgoingPictureBox's drag margin

        public const int HOME_FIRST_CONTRACT_THRESHOLD = 363;
        public const int HOME_SECOND_CONTRACT_THRESHOLD = 293;
        public const int HOME_CHAT_MIN_WIDTH_VISIBLE = 200;

        public const int HOME_OUTCHAT_HALF_HEIGHT = 64;
        public const int HOME_OUTCHAT_FULL_HEIGHT = 108;

        public const int HOME_CONTRACTED_CONTROL_DIST_TO_BOTTOM = 110;
        public const int HOME_EXPANDED_CONTROL_DIST_TO_BOTTOM = 180;

        public const int HOME_FIRSTBUTTONS_HEIGHT = 74;
        public const int HOME_SECONDBUTTONS_HEIGHT = 70;

        public const int HOME_INVIDEO_DIST_TO_BOTTOM = 203;
        public const int HOME_INVIDEO_VERTICAL_GUTTER = 59;
        public const int HOME_INVIDEO_HORIZONTAL_GUTTER = 20;
        public const int HOME_INVIDEO_INITIAL_WIDTH = 800;
        public const int HOME_INVIDEO_INITIAL_HEIGHT = 484;
        public const int HOME_INVIDEO_MINIMUM_WIDTH = 216;
        public const int HOME_INVIDEO_MINIMUM_HEIGHT = 162;

        public const int HOME_OUTVIDEO_INITIAL_WIDTH = 240;
        public const int HOME_OUTVIDEO_INITIAL_HEIGHT = 180;
        
        public const int HOME_OUTVIDEO_MIN_WIDTH_VISIBLE = 400;
        public const int HOME_OUTVIDEO_MIN_HEIGHT_VISIBLE = 300;
    }
}
